> For the complete documentation index, see [llms.txt](https://doc.commandersact.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://doc.commandersact.com/developers/tracking-and-integrations/tracking/about-events/js-sdk-event-specificity.md).

# Web event specificity

## Fields automatically added to event

The [JS SDK](/features/sources/sources-catalog/web/js-sdk.md), [Web container](/features/sources/sources-catalog/web/containers.md) and [GTM bridge](/features/sources/sources-catalog/web/gtm.md) add automatically specific properties in the event regarding the browser.\
Here is a complete event payload example :

```json
{
   "event_name": "search",
   "search_term": "t-shirts",
   "url": "https://www.mywebsite.com/path1/path2/", //Automatically added if missing
   "path": "/path1/path2/", //Automatically added
   "referrer": "https:///www.google.fr", //Automatically added
   "title": "My page title", //Automatically added if missing
   "user": {
      "id": "12345",
      "consistent_anonymous_id": "567892" //Automatically added
      "email": "toto@domain.fr",
      "consent_categories": ["1","3"] //Automatically added if you use Commanders Act CMP
   },
   "context": {
      "event_id": "202110130000000000", //Automatically added
      "generatorVersion": "10.0", //Automatically added
      "containerVersion": "3.1", //Automatically added
      "event_timestamp": "1639044446636", //Automatically added
      "page": { //Automatically added
         "title": "Search page", //Automatically added
         "url": "https://shop.com/search?q=...", //Automatically added
         "lang": "en", //Automatically added
         "referrer": "https:///www.google.fr", //Automatically added
         "viewport": { //Automatically added
            "width": 320, //Automatically added
            "height": 568 //Automatically added
         }
      },
      "device": { //Automatically added
         "user_agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.86 Safari/537.36",//Automatically added
         "ip": "102.3.4.56",//Automatically copied from the request header
         "lang": "fr",//Automatically added
         "cookie": "_fbp=123; _fbc=456; _ga=789",//Automatically added
         "timezone": "Europe/Paris"//Automatically added
      }
   }
}
```

## Fields automatically added

<table><thead><tr><th>Field name</th><th>Example value</th><th>Description</th></tr></thead><tbody><tr><td>context.event_id</td><td><pre><code>202110130000000000
</code></pre></td><td>Id of the event</td></tr><tr><td>context.event_timestamp</td><td><pre><code>1639044446636
</code></pre></td><td>Timestamp of the event sending time.</td></tr><tr><td>context.device.user_agent</td><td>Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/102.0.0.0 Safari/537.36</td><td>The browser's user agent</td></tr><tr><td>context.device.lang</td><td>fr</td><td>Browser language</td></tr><tr><td>path</td><td>/path1/path2/</td><td>Path of the current url (only on page_view)</td></tr><tr><td>referrer</td><td><a href="https://www.google.fr">https:///www.google.fr</a></td><td>Referer url (only on page_view)</td></tr><tr><td>title</td><td>My page title</td><td>Title of the current page (only on page_view)</td></tr><tr><td>url</td><td><a href="https://www.google.fr">https:///www.mywebsite.fr</a></td><td>Url of the current page</td></tr><tr><td>page.*</td><td></td><td>pages information</td></tr></tbody></table>

{% hint style="info" %}
IP Address is not collected by our libraries, but instead filled in by our servers when it receives a message for **client side events only**. Copying it from the request header containing the IP Address.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://doc.commandersact.com/developers/tracking-and-integrations/tracking/about-events/js-sdk-event-specificity.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
